/*
    This program does not do any of the filtering work.
    It creates child processes that do the filtering of
    the input to the output files.
*/
#include <windows.h>
#include <stdio.h>
#include <string.h>


/* error function prototype */
void printError(char* functionName);


int main(int argc, char *argv[])
{
   #define NUMBER_OF_PROCESSES ??

   STARTUPINFO startInfo;
   ZeroMemory(&startInfo, sizeof(startInfo));
   startInfo.cb = sizeof(startInfo);
   PROCESS_INFORMATION processInfo[NUMBER_OF_PROCESSES];
   HANDLE lpHandles[NUMBER_OF_PROCESSES];

   #define NUMBER_OF_FILES 10
   LPTSTR lpCommandLine[NUMBER_OF_FILES];

   /* Set up (partial) command lines */
   lpCommandLine[0] = "processWorker-child.exe snark0.txt output";
   lpCommandLine[1] = "processWorker-child.exe snark1.txt output";
   lpCommandLine[2] = "processWorker-child.exe snark2.txt output";
   lpCommandLine[3] = "processWorker-child.exe snark3.txt output";
   lpCommandLine[4] = "processWorker-child.exe snark4.txt output";
   lpCommandLine[5] = "processWorker-child.exe snark5.txt output";
   lpCommandLine[6] = "processWorker-child.exe snark6.txt output";
   lpCommandLine[7] = "processWorker-child.exe snark7.txt output";
   lpCommandLine[8] = "processWorker-child.exe snark8.txt output";
   lpCommandLine[9] = "processWorker-child.exe snark9.txt output";



   /* keep track of when we start working */
   beginTime = GetTickCount();

   /* this loop does all of the parent process's work */
   for (n = 0; n < NUMBER_OF_PROCESSES; n++)
   {

      // Randomly choose a command line,

      // Complete the output file name with a sequence number

      // Choose a random integer between 2 and 10 for the filter
      // in the child process to use. Append this number to the
      // end of the command line.

      // Use CreateProcess, and the constructed command line, to
      // create a child (worker) process. Be sure to error check
      // the call to CreateProcess, and you will need to keep track
      // of the process handle returned by CreateProcess.
   }

   /* wait for all child processes to end */
   printf("  waiting for child processes to complete...");
   WaitForMultipleObjects(processCount, lpHandles, TRUE, INFINITE);
   printf("\nAll processes completed.\n");

   /* determine when we finish working */
   printf("%d\n", GetTickCount()-beginTime);

   return 0;
}


/****************************************************************
   The following function can be used to print out "meaningful"
   error messages. If you call a Win32 function and it returns
   with an error condition, then call this function right away and
   pass it a string containing the name of the Win32 function that
   failed. This function will print out a reasonable text message
   explaining the error and then terminate the program.
*/
void printError(char* functionName)
{
   LPVOID lpMsgBuf;
    int error_no;
    error_no = GetLastError();
    FormatMessage(
         FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
         NULL,
         error_no,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
         (LPTSTR) &lpMsgBuf,
         0,
         NULL
    );
    // Display the string.
    fprintf(stderr, "\n%s failed on error %d: ", functionName, error_no);
    fprintf(stderr, lpMsgBuf);
    // Free the buffer.
    LocalFree( lpMsgBuf );
    ExitProcess(1);  // terminate the program
}//printError