/*
    This program does the filtering work using threads,
    one thread for each input file to output file filter.

    The main() function creates the worker threads and passes
    to them all of the parameters that they need.

    The thread() function does the filtering work.
*/
#include <windows.h>
#include <stdio.h>
#include <string.h>


/* error function prototype */
void printError(char* functionName);


/* Data structure needed for passing parameters to the threads */
typedef struct
{
   char* inFileName;
   char* outFileName;
   int offset;
}ThreadStuff_t;


int main(int argc, char *argv[])
{
   /* thread function prototype */
   DWORD WINAPI thread(LPVOID);


   #define NUMBER_OF_THREADS ??


   HANDLE threadHandle;
   HANDLE lpHandles[NUMBER_OF_THREADS];
   DWORD threadID;


   /* Here are the names of the input files */
   #define NUMBER_OF_FILES 10
   LPTSTR lpInFileName[NUMBER_OF_FILES];

   lpInFileName[0] = "snark0.txt";
   lpInFileName[1] = "snark1.txt";
   lpInFileName[2] = "snark2.txt";
   lpInFileName[3] = "snark3.txt";
   lpInFileName[4] = "snark4.txt";
   lpInFileName[5] = "snark5.txt";
   lpInFileName[6] = "snark6.txt";
   lpInFileName[7] = "snark7.txt";
   lpInFileName[8] = "snark8.txt";
   lpInFileName[9] = "snark9.txt";

   /* array to hold output file names */
   char lpOutFileName[10][15];

   /* array to hold thread parameters */
   ThreadStuff_t threadParams[NUMBER_OF_THREADS];


   /* keep track of when we start working */
   beginTime = GetTickCount();

   /* this loop creates all of the worker threads */
   for (n = 0; n < NUMBER_OF_THREADS; n++)
   {

      // Randomly choose an input file name.
      // Create a properly sequenced output file name.
      // Randomly choose an integer between 2 and 10 to be
      // used by the filter.
      // Put this data in an instance of the ThreadStuff_t
      // data structure.

      // Use CreateThread to create a worker thread. Pass
      // a pointer to the thread parameter data structure to
      // CreateThread. Keep track of the handle returned by
      // CreateThread; it is needed to determine when the thread
      // terminates. (Note: Don't confuse the thread handle
      // returned by CreateThread with the thread ID also returned
      // by CreatThread. The thread ID is interesting, but not
      // necessary for this program.)
   }

   /* wait for all worker threads to end */
   printf("  waiting for all threads to complete...");
   WaitForMultipleObjects(threadCount, lpHandles, TRUE, INFINITE);
   printf("\nAll threads completed.\n");

   /* determine when we finish working */
   printf("%d\n", GetTickCount()-beginTime);

   return 0;
}



DWORD WINAPI thread(LPVOID threadParam)
{

   /* This is how we get access to the thread parameters */
   ThreadStuff_t* threadParams_p = (ThreadStuff_t*)threadParam;


   // Get the input and output file names from the thread parameter
   // data structure.

   // Use CreateFile to open the input file for shared reading and
   // use CreateFile again to open the output file for writing.
   // (be sure to error check these calls)

   // Get the third parameter from the thread parameter data structure.

   // Filter the input file to the output file using the third
   // thread parameter to determine which characters get their
   // case changed (and, of course, error check).

   return 0;
}//thread




/****************************************************************
   The following function can be used to print out "meaningful"
   error messages. If you call a Win32 function and it returns
   with an error condition, then call this function right away and
   pass it a string containing the name of the Win32 function that
   failed. This function will print out a reasonable text message
   explaining the error and then terminate the program.
*/
void printError(char* functionName)
{
   LPVOID lpMsgBuf;
    int error_no;
    error_no = GetLastError();
    FormatMessage(
         FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
         NULL,
         error_no,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
         (LPTSTR) &lpMsgBuf,
         0,
         NULL
    );
    // Display the string.
    fprintf(stderr, "\n%s failed on error %d: ", functionName, error_no);
    fprintf(stderr, lpMsgBuf);
    // Free the buffer.
    LocalFree( lpMsgBuf );
    ExitProcess(1);  // terminate the program
}//printError